ServerEvents.recipes(e=> {
    const {
        alloy_smelting,
    } = e.recipes.enderio;
    e.replaceInput({mod:'refinedstorage'}, 'refinedstorage:quartz_enriched_iron', 'nwtc:red_aurum_ingot')
    //硅
    e.shapeless('refinedstorage:silicon', 
    [ 
        '#forge:silicon',
    ])
    //处理器粘合剂
    e.remove({ output: 'refinedstorage:processor_binding' })
    e.shapeless('8x refinedstorage:processor_binding', 
    [ 
        '2x industrialforegoing:dryrubber',
        '2x thermal:cured_rubber',
        'nwtc:gelatum',
    ])
    //机器外壳
    e.remove({ output: 'refinedstorage:machine_casing' })
    e.shapeless('refinedstorage:machine_casing', 
    [ 
        '#industrialforegoing:machine_frame/advanced',
    ])
    //控制器
    e.remove({output:'refinedstorage:controller',type: 'minecraft:crafting_shaped'})
    e.shaped('refinedstorage:controller',[
        'UEU', 
        'UCU', 
        'UDU'
       ], {
         U: '#forge:ingots/redstone_alloy',
         D: 'create:precision_mechanism',
         E: 'refinedstorage:advanced_processor',
         C: '#industrialforegoing:machine_frame/advanced'
       })
    //磁盘驱动器
    e.remove({output:'refinedstorage:disk_drive',type: 'minecraft:crafting_shaped'})
    e.shaped('refinedstorage:disk_drive',[
        'UEU', 
        'UCU', 
        'UDU'
       ], {
         U: '#forge:ingots/redstone_alloy',
         D: '#forge:energy_cell_1',
         E: 'refinedstorage:advanced_processor',
         C: '#industrialforegoing:machine_frame/advanced'
       })
     //终端
     e.remove({output:'refinedstorage:grid',type: 'minecraft:crafting_shaped'})
     e.shaped('refinedstorage:grid',[
         'UEU', 
         ' C ', 
         'UDU'
        ], {
          U: 'refinedstorage:advanced_processor',
          D: 'immersiveengineering:component_electronic_adv',
          E: 'create:precision_mechanism',
          C: 'storagenetwork:inventory'
        })
    
    //存储元件  
    e.replaceInput({output:'/refinedstorage\:.*storage_part/'}, 'minecraft:redstone', '#immersiveengineering:circuits/pcb')
    e.replaceInput({output:'/refinedstorage\:.*storage_part/'}, 'refinedstorage:quartz_enriched_iron', 'nwtc:red_aurum_ingot')
    e.replaceInput({output:'/refinedstorage\:.*storage_part/'}, 'minecraft:bucket', 'enderio:fluid_tank')

    e.replaceInput({mod:'extradisks'}, 'refinedstorage:quartz_enriched_iron', 'nwtc:energy_superconductivity_ingot')
    e.replaceInput({output:'/extradisks\:.*storage_part/'}, 'minecraft:redstone', 'mekanism:elite_control_circuit')
  
    //存储外壳
    e.replaceInput({output:'refinedstorage:storage_housing'}, 'minecraft:redstone', '#immersiveengineering:circuits/pcb')
    e.replaceInput({output:'refinedstorage:storage_housing'}, 'refinedstorage:quartz_enriched_iron', 'nwtc:red_aurum_ingot')
    //存储磁盘
    e.replaceInput({output:'/refinedstorage\:.*storage_disk/'}, 'refinedstorage:quartz_enriched_iron', 'nwtc:red_aurum_ingot')
    e.replaceInput({output:'/extradisks\:.*storage_disk/'}, 'refinedstorage:quartz_enriched_iron', 'nwtc:energy_superconductivity_ingot')

    //额外存储
    e.replaceInput({mod:'extrastorage'}, 'refinedstorage:quartz_enriched_iron', 'nwtc:energy_superconductivity_ingot')
    e.replaceInput({mod:'extrastorage'}, 'minecraft:redstone', 'mekanism:elite_control_circuit')
    e.replaceInput({mod:'extrastorage'}, 'refinedstorage:machine_casing', 'industrialforegoing:machine_frame_supreme')
    e.replaceInput({mod:'extrastorage'}, 'minecraft:redstone_torch', 'nwtc:energy_superconductivity_ingot')
    e.replaceInput({mod:'extrastorage'}, 'minecraft:iron_ingot', 'nwtc:red_aurum_ingot')

    //存储重置
    e.replaceInput({mod:'rebornstorage'}, 'refinedstorage:quartz_enriched_iron', 'nwtc:red_aurum_ingot')
    e.replaceInput({mod:'rebornstorage'}, 'minecraft:redstone', '#immersiveengineering:circuits/pcb')
    

    //石英铁
    e.remove({output:'refinedstorage:quartz_enriched_iron',type: 'minecraft:crafting_shaped'})
    alloy_smelting("refinedstorage:quartz_enriched_iron", ["12x #forge:gems/quartz", "16x #forge:ingots/iron","4x #forge:clay"], 40000);
    //机器外壳

})